//+------------------------------------------------------------------+
//|												 Copyright  2010, JACreative |
//|																 KGForexWorld.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, KGForexWorld.com"
#property link      "http://www.kgforexworld.com"

#property indicator_chart_window
#property indicator_buffers 0


extern	int		JumlahBar		= 5,
						Sinkron			= 0;
extern	color		Warna				= DarkOrange;
extern	bool		BellCurve 		= false,
						ID 				= true,
						Harga 			= true;
extern	int		LabelDistance	= 30;
extern	int		Per	= 30;
extern   color    Curve_Color    = FireBrick;
extern   color		InfoColor      = clrBlack;
extern   string   ForSymbol      = "GBPUSD";

int		PerPNow,PerPNowScale,SAVEPER,SAVE_LINETIME,handle,COUNT[],TMP_COUNT[],CountMax;

double	HIGHER,LOWER,LOWEST,HIGHEST,HIGH,LOW,MAXPrice;

string	LabelName,NamaFile;

bool		FIRST	= true;

datetime	LINETIME,SAVETIME,TSearch;

//+------------------------------------------------------------------+
//| init()                     												   |
//+------------------------------------------------------------------+
int init() { return(0); }   


//+-------------------------------------------------------------------+
//| deinit													                      |
//+-------------------------------------------------------------------+
int deinit(){
	int i,strlen,obj_total;
	string name;
	obj_total	= ObjectsTotal();
	strlen		= StringLen(LabelName);
	for(i=obj_total;i>=0;i--){
		name	= ObjectName(i);
		if(StringSubstr(name, 0, strlen) == LabelName)
			ObjectDelete(name);
	}
	return(0);
}


//+-------------------------------------------------------------------+
//| deinit													                      |
//+-------------------------------------------------------------------+
void DELOBJ(){
	int i,strlen,obj_total;
	string name;
	obj_total	= ObjectsTotal();
	strlen		= StringLen(LabelName+"OBJ");
	for(i=obj_total;i>=0;i--){
		name	= ObjectName(i);
		if(StringSubstr(name, 0, strlen) == LabelName+"OBJ")
			ObjectDelete(name);
	}
}


//+------------------------------------------------------------------+
//| start()                     												   |
//+------------------------------------------------------------------+
int start()
{
	int			i,Jarak,ARRAYCount[],TMP;
	double		j,ArraySinkronHigh[],ArraySinkronLow[];
	datetime		ArraySinkronTime[];



   double _point = MarketInfo(ForSymbol,MODE_POINT);
		LOWEST	= iLow(ForSymbol,0,iLowest(ForSymbol,0,MODE_LOW,Per,0))-(100*_point);
		HIGHEST	= iHigh(ForSymbol,0,iHighest(ForSymbol,0,MODE_HIGH,Per,0))+(100*_point);
		Jarak		= (HIGHEST - LOWEST)/_point;

		ArrayResize(COUNT, Jarak);
		ArrayResize(TMP_COUNT, Jarak);
		ArrayInitialize(COUNT, 0);
		ArrayInitialize(TMP_COUNT, 0);

		ArrayCopySeries(ArraySinkronHigh, MODE_HIGH, ForSymbol, Sinkron);
		ArrayCopySeries(ArraySinkronLow,  MODE_LOW, ForSymbol, Sinkron);
		ArrayCopySeries(ArraySinkronTime, MODE_TIME, ForSymbol, Sinkron);

		for(i=Per;i>=0;i--)
		{
			for(j=ArraySinkronLow[i];j<=ArraySinkronHigh[i];j+=Point)
			{
				TMP	= NormalizeDouble(j/_point,0)-NormalizeDouble(LOWEST/_point,0);
				COUNT[TMP] ++;
			}
		}// END FOR
		MAXPrice	= (JA_ArrayMaximum(COUNT)*_point)+LOWEST;
		Comment(MAXPrice);
		double supres = MAXPrice;

		for(j=ArraySinkronLow[0];j<=ArraySinkronHigh[0];j+=_point){
			TMP	= NormalizeDouble(j/_point,0)-NormalizeDouble(LOWEST/_point,0);
			COUNT[TMP] --;
		}
		JA_ArrayCopy(TMP_COUNT, COUNT);
		SAVEPER			= Bars;
		CountMax			= COUNT[JA_ArrayMaximum(COUNT)];
		
		
		
		
		

	 MqlTick last_tick;
			 			    if(SymbolInfoTick(ForSymbol,last_tick))
     {
      Print(last_tick.time," Bid = ",last_tick.bid,
            " Ask = ",last_tick.ask,"  Volume = ",last_tick.volume);
     }
			 			
			 			 double currentprice = last_tick.bid; 
			 			 //Comment(currentprice);
			 			 //Comment(Market_Price);
	double di= currentprice;
	//double di= Market_Price;
	double diff;
	diff = di -supres;
	
	//Comment(diff);
	ObjectCreate("str1", OBJ_LABEL, 0, 0, 0);
   ObjectSet("str1", OBJPROP_CORNER, 0);
   ObjectSet("str1", OBJPROP_XDISTANCE, 300);
   ObjectSet("str1", OBJPROP_YDISTANCE, 130);
   ObjectSetText("str1", "...", 12, "Verdana Bold", InfoColor);
      ObjectSetText("str1","pip difference",12, "Verdana Bold", InfoColor);
      
      ObjectCreate("str2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("str2", OBJPROP_CORNER, 0);
   ObjectSet("str2", OBJPROP_XDISTANCE, 430);
   ObjectSet("str2", OBJPROP_YDISTANCE, 130);
   ObjectSetText("str2", "...", 12, "Verdana Bold", InfoColor);
      ObjectSetText("str2",diff,12, "Verdana Bold", InfoColor);
      
                  ObjectCreate("ED1", OBJ_LABEL, 0, 0, 0);
   ObjectSet("ED1", OBJPROP_CORNER, 0);
   ObjectSet("ED1", OBJPROP_XDISTANCE, 503);
   ObjectSet("ED1", OBJPROP_YDISTANCE, 230);
   ObjectSetText("ED1", "...", 12, "Verdana Bold", InfoColor);
      ObjectSetText("ED1","MP price",12, "Verdana Bold", InfoColor);
      
             ObjectCreate("ED2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("ED2", OBJPROP_CORNER, 0);
   ObjectSet("ED2", OBJPROP_XDISTANCE, 608);
   ObjectSet("ED2", OBJPROP_YDISTANCE, 230);
   ObjectSetText("ED2", "...", 12, "Verdana Bold", InfoColor);
      ObjectSetText("ED2",supres,12, "Verdana Bold", InfoColor); 
      return(0);
}


//+------------------------------------------------------------------+
//|  JA_ArrayMaximum                                                    |
//+------------------------------------------------------------------+
int JA_ArrayMaximum(int &ARY[])
  {
	int i,TOTAL,CATAT=0;
	TOTAL = ArraySize(ARY);

	for(i=0;i<TOTAL;i++){
		if(ARY[i] > ARY[CATAT]){
			CATAT 	= i;
		}
	}
	return(CATAT);
}


//+------------------------------------------------------------------+
//|  JA_ArrayCopy                                                    |
//+------------------------------------------------------------------+
void JA_ArrayCopy(int &ARY_DEST[], int &ARY_SOURCE[])
{
	int i,TOTAL,CATAT=0;
	TOTAL = ArraySize(ARY_DEST);

	for(i=0;i<TOTAL;i++){
		ARY_DEST[i] = ARY_SOURCE[i];
	}

}


//+------------------------------------------------------------------+
//|  ScaleValue                                                    |
//+------------------------------------------------------------------+
int ScaleValue(double x, double in_min, double in_max, double out_min, double out_max) {
	return(MathFloor((x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min));
}




